---
title: WebGLRenderingContext.blendFuncSeparate()
slug: Web/API/WebGLRenderingContext/blendFuncSeparate
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.blendFuncSeparate()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> defines which function is used for blending pixel arithmetic for RGB and alpha components separately.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.blendFuncSeparate(srcRGB, dstRGB, srcAlpha, dstAlpha);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>srcRGB</code></dt>
 <dd>A {{domxref("GLenum")}} specifying a multiplier for the red, green and blue (RGB) source blending factors. The default value is <code>gl.ONE</code>. For possible values, see below.</dd>
 <dt><code>dstRGB</code></dt>
 <dd>A {{domxref("GLenum")}} specifying a multiplier for the red, green and blue (RGB) destination blending factors. The default value is <code>gl.ZERO</code>. For possible values, see below.</dd>
 <dt><code>srcAlpha</code></dt>
 <dd>A {{domxref("GLenum")}} specifying a multiplier for the alpha source blending factor. The default value is <code>gl.ONE</code>. For possible values, see below.</dd>
 <dt><code>dstAlpha</code></dt>
 <dd>A {{domxref("GLenum")}} specifying a multiplier for the alpha destination blending factor. The default value is <code>gl.ZERO</code>. For possible values, see below.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>If <em>srcRGB</em>, <em>dstRGB</em>, <em>srcAlpha</em>, or <em>dstAlpha</em> is not one of the listed possible values, a <code>gl.INVALID_ENUM</code> error is thrown.</li>
 <li>If a constant color and a constant alpha value are used together as source (<code>srcRGB</code>) and destination (<code>dstRGB</code>) factors, a <code>gl.INVALID_ENUM</code> error is thrown.</li>
</ul>

<h2 id="Constants">Constants</h2>

<p>The following constants can be used for <em>srcRGB</em>, <em>dstRGB</em>, <em>srcAlpha</em>, and <em>dstAlpha</em></p>

<p>The formulas for the blending factors can be described like this (all RGBA values are between 0 and 1):</p>

<ul>
 <li>color(RGB) = (sourceColor * <em>srcRGB</em>) + (destinationColor * <em>dstRGB</em>)</li>
 <li>color(A) = (sourceAlpha * <em>srcAlpha</em>) + (destinationAlpha * <em>dstAlpha</em>)</li>
</ul>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Constant</th>
   <th scope="col">RGB factor</th>
   <th scope="col">Alpha factor</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>gl.ZERO</code></td>
   <td>0,0,0</td>
   <td>0</td>
   <td>Multiplies all colors by 0.</td>
  </tr>
  <tr>
   <td><code>gl.ONE</code></td>
   <td>1,1,1,1</td>
   <td>1</td>
   <td>Multiplies all colors by 1.</td>
  </tr>
  <tr>
   <td><code>gl.SRC_COLOR</code></td>
   <td>R<sub>S</sub>, G<sub>S</sub>, B<sub>S</sub></td>
   <td>A<sub>S</sub></td>
   <td>Multiplies all colors by the source colors.</td>
  </tr>
  <tr>
   <td><code>gl.ONE_MINUS_SRC_COLOR</code></td>
   <td>1-R<sub>S</sub>, 1-G<sub>S</sub>, 1-B<sub>S</sub></td>
   <td>1-A<sub>S</sub></td>
   <td>Multiplies all colors by 1 minus each source color.</td>
  </tr>
  <tr>
   <td><code>gl.DST_COLOR</code></td>
   <td>R<sub>D</sub>, G<sub>D</sub>, B<sub>D</sub></td>
   <td>A<sub>D</sub></td>
   <td>Multiplies all colors by the destination color.</td>
  </tr>
  <tr>
   <td><code>gl.ONE_MINUS_DST_COLOR</code></td>
   <td>1-R<sub>D</sub>, 1-G<sub>D</sub>, 1-B<sub>D</sub></td>
   <td>1-A<sub>D</sub></td>
   <td>Multiplies all colors by 1 minus each destination color.</td>
  </tr>
  <tr>
   <td><code>gl.SRC_ALPHA</code></td>
   <td>A<sub>S</sub>, A<sub>S</sub>, A<sub>S</sub></td>
   <td>A<sub>S</sub></td>
   <td>Multiplies all colors by the source alpha color.</td>
  </tr>
  <tr>
   <td><code>gl.ONE_MINUS_SRC_ALPHA</code></td>
   <td>1-A<sub>S</sub>, 1-A<sub>S</sub>, 1-A<sub>S</sub></td>
   <td>1-A<sub>S</sub></td>
   <td>Multiplies all colors by 1 minus the source alpha color.</td>
  </tr>
  <tr>
   <td><code>gl.DST_ALPHA</code></td>
   <td>A<sub>D</sub>, A<sub>D</sub>, A<sub>D</sub></td>
   <td>A<sub>D</sub></td>
   <td>Multiplies all colors by the destination alpha color.</td>
  </tr>
  <tr>
   <td><code>gl.ONE_MINUS_DST_ALPHA</code></td>
   <td>1-A<sub>D</sub>, 1-A<sub>D</sub>, 1-A<sub>D</sub></td>
   <td>1-A<sub>D</sub></td>
   <td>Multiplies all colors by 1 minus the destination alpha color.</td>
  </tr>
  <tr>
   <td><code>gl.CONSTANT_COLOR</code></td>
   <td>R<sub>C</sub>, G<sub>C</sub>, B<sub>C</sub></td>
   <td>A<sub>C</sub></td>
   <td>Multiplies all colors by a constant color.</td>
  </tr>
  <tr>
   <td><code>gl.ONE_MINUS_CONSTANT_COLOR</code></td>
   <td>1-R<sub>C</sub>, 1-G<sub>C</sub>, 1-B<sub>C</sub></td>
   <td>1-A<sub>C</sub></td>
   <td>Multiplies all colors by 1 minus a constant color.</td>
  </tr>
  <tr>
   <td><code>gl.CONSTANT_ALPHA</code></td>
   <td>A<sub>C</sub>, A<sub>C</sub>, A<sub>C</sub></td>
   <td>A<sub>C</sub></td>
   <td>Multiplies all colors by a constant alpha value.</td>
  </tr>
  <tr>
   <td><code>gl.ONE_MINUS_CONSTANT_ALPHA</code></td>
   <td>1-A<sub>C</sub>, 1-A<sub>C</sub>, 1-A<sub>C</sub></td>
   <td>1-A<sub>C</sub></td>
   <td>Multiplies all colors by 1 minus a constant alpha value.</td>
  </tr>
  <tr>
   <td><code>gl.SRC_ALPHA_SATURATE</code></td>
   <td>
    <p>min(A<sub>S</sub>, 1 - A<sub>D</sub>), min(A<sub>S</sub>, 1 - A<sub>D</sub>), min(A<sub>S</sub>, 1 - A<sub>D</sub>)</p>
   </td>
   <td>1</td>
   <td>Multiplies the RGB colors by the smaller of either the source alpha color or the value of 1 minus the destination alpha color. The alpha value is multiplied by 1.</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>To use the blend function, you first have to activate blending with {{domxref("WebGLRenderingContext.enable()")}} with the argument <code>gl.BLEND</code>.</p>

<pre class="brush: js">gl.enable(gl.BLEND);
gl.blendFuncSeparate(gl.SRC_COLOR, gl.DST_COLOR, gl.ONE, gl.ZERO);
</pre>

<p>To get the current blend function, query the <code>BLEND_SRC_RGB</code>, <code>BLEND_SRC_ALPHA</code>, <code>BLEND_DST_RGB</code>, and <code>BLEND_DST_ALPHA</code> constants which return one of the blend function constants.</p>

<pre class="brush: js">gl.enable(gl.BLEND);
gl.blendFuncSeparate(gl.SRC_COLOR, gl.DST_COLOR, gl.ONE, gl.ZERO);
gl.getParameter(gl.BLEND_SRC_RGB) == gl.SRC_COLOR;
// true
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.3", "blendFunc")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition.<br>
    In WebGL, constant color and constant alpha cannot be used together as source and destination factors in the blend function. See section 6.13. of the specification.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glBlendFunc.xml", "glBlendFunc")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.blendFuncSeparate")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.blendColor()")}}</li>
 <li>{{domxref("WebGLRenderingContext.blendEquation()")}}</li>
</ul>
